type uint = int

type t = {
  r: uint;
  g: uint;
  b: uint;
  a: uint;
}

let init ~r ~g ~b ?(a = 255) () =
  { r; g; b; a }

let rgba (r, g, b, a) =
  { r; g; b; a }

let rgb (r, g, b) =
  { r; g; b; a = 255 }

let aliceblue = rgb (240, 248, 255)
let antiquewhite = rgb (250, 235, 215)
let aqua = rgb ( 0, 255, 255)
let aquamarine = rgb (127, 255, 212)
let azure = rgb (240, 255, 255)
let beige = rgb (245, 245, 220)
let bisque = rgb (255, 228, 196)
let black = rgb ( 0, 0, 0)
let blanchedalmond = rgb (255, 235, 205)
let blue = rgb ( 0, 0, 255)
let blueviolet = rgb (138, 43, 226)
let brown = rgb (165, 42, 42)
let burlywood = rgb (222, 184, 135)
let cadetblue = rgb ( 95, 158, 160)
let chartreuse = rgb (127, 255, 0)
let chocolate = rgb (210, 105, 30)
let coral = rgb (255, 127, 80)
let cornflowerblue = rgb (100, 149, 237)
let cornsilk = rgb (255, 248, 220)
let crimson = rgb (220, 20, 60)
let cyan = rgb ( 0, 255, 255)
let darkblue = rgb ( 0, 0, 139)
let darkcyan = rgb ( 0, 139, 139)
let darkgoldenrod = rgb (184, 134, 11)
let darkgray = rgb (169, 169, 169)
let darkgreen = rgb ( 0, 100, 0)
let darkgrey = rgb (169, 169, 169)
let darkkhaki = rgb (189, 183, 107)
let darkmagenta = rgb (139, 0, 139)
let darkolivegreen = rgb ( 85, 107, 47)
let darkorange = rgb (255, 140, 0)
let darkorchid = rgb (153, 50, 204)
let darkred = rgb (139, 0, 0)
let darksalmon = rgb (233, 150, 122)
let darkseagreen = rgb (143, 188, 143)
let darkslateblue = rgb ( 72, 61, 139)
let darkslategray = rgb ( 47, 79, 79)
let darkslategrey = rgb ( 47, 79, 79)
let darkturquoise = rgb ( 0, 206, 209)
let darkviolet = rgb (148, 0, 211)
let deeppink = rgb (255, 20, 147)
let deepskyblue = rgb ( 0, 191, 255)
let dimgray = rgb (105, 105, 105)
let dimgrey = rgb (105, 105, 105)
let dodgerblue = rgb ( 30, 144, 255)
let firebrick = rgb (178, 34, 34)
let floralwhite = rgb (255, 250, 240)
let forestgreen = rgb ( 34, 139, 34)
let fuchsia = rgb (255, 0, 255)
let gainsboro = rgb (220, 220, 220)
let ghostwhite = rgb (248, 248, 255)
let gold = rgb (255, 215, 0)
let goldenrod = rgb (218, 165, 32)
let gray = rgb (128, 128, 128)
let grey = rgb (128, 128, 128)
let green = rgb ( 0, 128, 0)
let greenyellow = rgb (173, 255, 47)
let honeydew = rgb (240, 255, 240)
let hotpink = rgb (255, 105, 180)
let indianred = rgb (205, 92, 92)
let indigo = rgb ( 75, 0, 130)
let ivory = rgb (255, 255, 240)
let khaki = rgb (240, 230, 140)
let lavender = rgb (230, 230, 250)
let lavenderblush = rgb (255, 240, 245)
let lawngreen = rgb (124, 252, 0)
let lemonchiffon = rgb (255, 250, 205)
let lightblue = rgb (173, 216, 230)
let lightcoral = rgb (240, 128, 128)
let lightcyan = rgb (224, 255, 255)
let lightgoldenrodyellow = rgb (250, 250, 210)
let lightgray = rgb (211, 211, 211)
let lightgreen = rgb (144, 238, 144)
let lightgrey = rgb (211, 211, 211)
let lightpink = rgb (255, 182, 193)
let lightsalmon = rgb (255, 160, 122)
let lightseagreen = rgb ( 32, 178, 170)
let lightskyblue = rgb (135, 206, 250)
let lightslategray = rgb (119, 136, 153)
let lightslategrey = rgb (119, 136, 153)
let lightsteelblue = rgb (176, 196, 222)
let lightyellow = rgb (255, 255, 224)
let lime = rgb ( 0, 255, 0)
let limegreen = rgb ( 50, 205, 50)
let linen = rgb (250, 240, 230)
let magenta = rgb (255, 0, 255)
let maroon = rgb (128, 0, 0)
let mediumaquamarine = rgb (102, 205, 170)
let mediumblue = rgb ( 0, 0, 205)
let mediumorchid = rgb (186, 85, 211)
let mediumpurple = rgb (147, 112, 219)
let mediumseagreen = rgb ( 60, 179, 113)
let mediumslateblue = rgb (123, 104, 238)
let mediumspringgreen = rgb ( 0, 250, 154)
let mediumturquoise = rgb ( 72, 209, 204)
let mediumvioletred = rgb (199, 21, 133)
let midnightblue = rgb ( 25, 25, 112)
let mintcream = rgb (245, 255, 250)
let mistyrose = rgb (255, 228, 225)
let moccasin = rgb (255, 228, 181)
let navajowhite = rgb (255, 222, 173)
let navy = rgb ( 0, 0, 128)
let oldlace = rgb (253, 245, 230)
let olive = rgb (128, 128, 0)
let olivedrab = rgb (107, 142, 35)
let orange = rgb (255, 165, 0)
let orangered = rgb (255, 69, 0)
let orchid = rgb (218, 112, 214)
let palegoldenrod = rgb (238, 232, 170)
let palegreen = rgb (152, 251, 152)
let paleturquoise = rgb (175, 238, 238)
let palevioletred = rgb (219, 112, 147)
let papayawhip = rgb (255, 239, 213)
let peachpuff = rgb (255, 218, 185)
let peru = rgb (205, 133, 63)
let pink = rgb (255, 192, 203)
let plum = rgb (221, 160, 221)
let powderblue = rgb (176, 224, 230)
let purple = rgb (128, 0, 128)
let red = rgb (255, 0, 0)
let rosybrown = rgb (188, 143, 143)
let royalblue = rgb ( 65, 105, 225)
let saddlebrown = rgb (139, 69, 19)
let salmon = rgb (250, 128, 114)
let sandybrown = rgb (244, 164, 96)
let seagreen = rgb ( 46, 139, 87)
let seashell = rgb (255, 245, 238)
let sienna = rgb (160, 82, 45)
let silver = rgb (192, 192, 192)
let skyblue = rgb (135, 206, 235)
let slateblue = rgb (106, 90, 205)
let slategray = rgb (112, 128, 144)
let slategrey = rgb (112, 128, 144)
let snow = rgb (255, 250, 250)
let springgreen = rgb ( 0, 255, 127)
let steelblue = rgb ( 70, 130, 180)
let tan = rgb (210, 180, 140)
let teal = rgb ( 0, 128, 128)
let thistle = rgb (216, 191, 216)
let tomato = rgb (255, 99, 71)
let transparent = rgba (0,0,0,0)
let turquoise = rgb ( 64, 224, 208)
let violet = rgb (238, 130, 238)
let wheat = rgb (245, 222, 179)
let white = rgb (255, 255, 255)
let whitesmoke = rgb (245, 245, 245)
let yellow = rgb (255, 255, 0)
let yellowgreen = rgb (154, 205, 50)

let gray10 = rgb (26,26,26)
let gray20 = rgb (51,51,51)
let gray30 = rgb (77,77,77)
let gray40 = rgb (104,104,104)
let gray50 = rgb (128,128,128)
let gray60 = rgb (153,153,153)
let gray70 = rgb (178,178,178)
let gray80 = rgb (204,204,204)
let gray90 = rgb (230,230,230)
