/* ocaml-clanlib: ocaml bindings to the clanlib
 Copyright (C) 2013 Florent Monnier (monnier dot florent on gmail)
 Code provided under MIT license:
 See the file MIT_License.txt or this URL:
 http://opensource.org/licenses/mit-license.php
 This software is provided "AS IS", without warranty of any kind. */

#include <ClanLib/Core/XML/dom_element.h>
#include "cl_caml_incs.hpp"
#include "cl_caml_conv.hpp"
#include "CL_DomElement_stub.hpp"

CAMLextern_C value
caml_CL_DomElement_init(value unit)
{
    CL_DomElement *elem = new CL_DomElement();
    return Val_CL_DomElement(elem);
}
/*
    CL_DomElement(
            CL_DomDocument &doc,
            const CL_DomString &tag_name,
            const CL_DomString &namespace_uri = CL_DomString());

    CL_DomElement(const CL_SharedPtr<CL_DomNode_Generic> &impl);
*/

CAMLextern_C value
caml_CL_DomElement_delete(value elem)
{
    delete CL_DomElement_val(elem);
    nullify_ptr(elem);
    return Val_unit;
}

// vim: sw=4 sts=4 ts=4 et
