/* ocaml-clanlib: ocaml bindings to the clanlib
 Copyright (C) 2013 Florent Monnier (monnier dot florent on gmail)
 Code provided under MIT license:
 See the file MIT_License.txt or this URL:
 http://opensource.org/licenses/mit-license.php
 This software is provided "AS IS", without warranty of any kind. */

#include <ClanLib/Core/IOData/file.h>
#include "cl_caml_incs.hpp"
#include "cl_caml_conv.hpp"
#include "cl_caml_gen.hpp"
#include "CL_File_stub.hpp"

CAMLextern_C value
caml_CL_File_init(value filename)
{
    CL_File *file = new CL_File();
    *file = CL_File(CL_String_val(filename));
    return Val_CL_File(file);
}

CAMLextern_C value
caml_CL_File_delete(value file)
{
    delete CL_File_val(file);
    nullify_ptr(file);
    return Val_unit;
}

// vim: sw=4 sts=4 ts=4 et
