/* ocaml-clanlib: ocaml bindings to the clanlib
 Copyright (C) 2013 Florent Monnier (monnier dot florent on gmail)
 Code provided under MIT license:
 See the file MIT_License.txt or this URL:
 http://opensource.org/licenses/mit-license.php
 This software is provided "AS IS", without warranty of any kind. */

#include <ClanLib/Core/Math/point.h>
#include "cl_caml_incs.hpp"
#include "CL_Point_stub.hpp"

value
Val_CL_Point(const CL_Point& c)
{
    CAMLparam0();
    CAMLlocal1(ret);
    ret = caml_alloc(2, 0);
    Store_field(ret, 0, Val_long(c.x));
    Store_field(ret, 1, Val_long(c.y));
    CAMLreturn(ret);
}

value
Val_CL_Pointf(const CL_Pointf& c)
{
    CAMLparam0();
    CAMLlocal1(ret);
    ret = caml_alloc(2, 0);
    Store_field(ret, 0, caml_copy_double(c.x));
    Store_field(ret, 1, caml_copy_double(c.y));
    CAMLreturn(ret);
}

CL_Point
CL_Point_val(value pnt)
{
    int x = Long_val(Field(pnt,0));
    int y = Long_val(Field(pnt,1));
    return CL_Point(x, y);
}

CL_Pointf
CL_Pointf_val(value pnt)
{
    double x = Double_val(Field(pnt,0));
    double y = Double_val(Field(pnt,1));
    return CL_Pointf(x, y);
}

// vim: sw=4 sts=4 ts=4 et
