/* ocaml-clanlib: ocaml bindings to the clanlib
 Copyright (C) 2013 Florent Monnier (monnier dot florent on gmail)
 Code provided under MIT license:
 See the file MIT_License.txt or this URL:
 http://opensource.org/licenses/mit-license.php
 This software is provided "AS IS", without warranty of any kind. */

#include <ClanLib/Display/setup_display.h>
#include "cl_caml_incs.hpp"
#include "cl_caml_conv.hpp"
#include "CL_SetupDisplay_stub.hpp"

CAMLextern_C value
caml_CL_SetupDisplay_init(value unit)
{
    CL_SetupDisplay *setup_display = new CL_SetupDisplay;
    return Val_CL_SetupDisplay(setup_display);
}

CAMLextern_C value
caml_CL_SetupDisplay_delete(value setup_display)
{
    delete CL_SetupDisplay_val(setup_display);
    nullify_ptr(setup_display);
    return Val_unit;
}

// vim: sw=4 sts=4 ts=4 et
